#!/usr/bin/env node
"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}function changes(){return transmute__default({}).extend("rawTags",gatherTags).extend("tags",parseTags).extend("latest",latestReleaseTag).extend("from",({latest:e})=>e.tag).extend("changes",gatherChanges)}function list(){return transmute__default({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("packageNames",findPackages).extend("packages",getPackageDetails)}function dependencies(...e){return list(...e).extend("dependencies",getDependencies)}function check(...e){return list(...e).extend("checks",publishCheck)}function publish(...e){return check(...e).extend("publishable",({packages:e,checks:t})=>e.filter(e=>t.packages[e.name].publishable)).extend("destination",destinationDetails).extend("publishing",getPublishing)}function version(...e){return publish(...e).extend(changes(...e).then(transmute.isolate(["changes","latest"]))).extend("dependencies",dependencies(...e).then(transmute.isolate("dependencies"))).extend("updates",recommendVersions)}function prerelease(...e){return check(...e).extend("unpublishable",({packages:e,checks:t})=>e.filter(e=>!t.packages[e.name].publishable)).extend("package",({unpublishable:e})=>pickPackage({message:"Which package should we prerelease?",packages:e})).extend("fixable",({package:{name:e},checks:t})=>Object.entries(t.packages[e]).filter(([e])=>solvable.includes(e)).filter(([,e])=>!e).map(([e])=>e)).extend("fixes",({package:e,fixable:t})=>Promise.all(t.map(t=>fixers[t](e).then(e=>({[t]:e})))).then(e=>e.reduce(collapse,{})))}function build(...e){const t=e[0].packageNames;return(t.length>0?transmute.transmute({packageNames:t}).extend("root",findRepoRoot).extend("packages",getPackageDetails).extend("baseConfig",findBaseConfig):transmute.transmute(publish(...e).then(e=>_extends({},e,{packages:e.publishable})))).extend("dependencies",dependencies(...e).then(transmute.isolate("dependencies"))).extend("configs",buildRollupConfigs(plugins))}var chalk=require("chalk"),parse=_interopDefault(require("minimist")),RenderKid=_interopDefault(require("renderkid")),transmute=require("transmutation"),transmute__default=_interopDefault(transmute),toCamelCase=_interopDefault(require("to-camel-case")),prettyjson=require("prettyjson"),TS=_interopDefault(require("trie-search"));require("loud-rejection/register");var configureGit=_interopDefault(require("simple-git/promise")),fs=require("fs"),fs__default=_interopDefault(fs),unglob=_interopDefault(require("glob")),match=_interopDefault(require("minimatch")),promisify=_interopDefault(require("es6-promisify")),path=require("path"),findUp=_interopDefault(require("find-up")),pick=_interopDefault(require("lodash.pick")),fileExists=require("file-exists"),uniq=_interopDefault(require("lodash.uniq")),find=_interopDefault(require("lodash.find")),keyBy=_interopDefault(require("lodash.keyby")),detective=_interopDefault(require("detective-es6")),frontMatter=_interopDefault(require("front-matter")),map=_interopDefault(require("lodash.map")),jsonFile=_interopDefault(require("jsonfile")),filter=_interopDefault(require("lodash.filter")),intersect=_interopDefault(require("lodash.intersection")),semver=require("semver"),execa=_interopDefault(require("execa")),registryUrl=_interopDefault(require("registry-url")),localOrHomeNpmrc=_interopDefault(require("local-or-home-npmrc")),has=_interopDefault(require("lodash.has")),every=_interopDefault(require("lodash.every")),partial=_interopDefault(require("lodash.partial")),editor=_interopDefault(require("external-editor")),fuzzy=require("fuzzy"),inquirer=_interopDefault(require("inquirer")),autocomplete=_interopDefault(require("inquirer-autocomplete-prompt")),rollup=require("rollup"),exec=_interopDefault(require("rollup-plugin-executable")),uglifyEs=require("uglify-es"),babel=_interopDefault(require("rollup-plugin-babel")),uglify=_interopDefault(require("rollup-plugin-uglify")),filesize=_interopDefault(require("rollup-plugin-filesize")),markdown=_interopDefault(require("rollup-plugin-markdown")),resolve$1=_interopDefault(require("rollup-plugin-node-resolve")),rimraf=_interopDefault(require("rimraf")),commonjs=_interopDefault(require("rollup-plugin-commonjs")),globals=_interopDefault(require("rollup-plugin-node-globals")),vuePlugin=_interopDefault(require("rollup-plugin-vue")),asyncToGenerator=function(e){return function(){var t=e.apply(this,arguments);return new Promise(function(e,n){function r(i,a){try{var s=t[i](a),o=s.value}catch(e){return void n(e)}if(!s.done)return Promise.resolve(o).then(function(e){r("next",e)},function(e){r("throw",e)});e(o)}return r("next")})}},_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},toArray=function(e){return Array.isArray(e)?e:Array.from(e)},convertArgs=(e,t={})=>Object.entries(e).map(([e,t])=>["_"!==e?toCamelCase(e):e,t]).map(([e,n])=>e in t?[t[e],n]:[e,n]).reduce((e,t)=>_extends({},e,{[t[0]]:t[1]}),{}),createSearcher=({commands:e=[]}={})=>{const t=e.map(e=>{const t=Array.isArray(e.aliases)?e.aliases:[e.aliases];return _extends({},e,{tokens:[e.name,...t].join(" ")})}),n=new TS(["tokens"]);return n.addAll(t),n};const jsonRender=e=>t=>console.log(prettyjson.render(transmute.isolate(e)(t))),configureKli=({defaultStyle:e,defaultRenderer:t=console.log}={})=>({commands:n=[]}={})=>{if(!Array.isArray(n))throw new Error("Commands must be an array");if(0===n.length)throw new Error("No commands defined");n.forEach(e=>{if("function"!=typeof e.run)throw new Error("All commands must have a run method")});const r=createSearcher({commands:n});return{execute:(i=[""])=>{const a=parse(i,{boolean:!0}),s=a._,o=a.commit,l=a.json,c=r.get(s[0]),u=0===c.length&&1===n.length?n[0]:c[0];if(!u)return console.log(chalk.red(`No command associated with \`${s[0]}\``));const p=convertArgs(_extends({},a,{_:a._.slice(1)}),u.args),d=Promise.resolve(u.run(p));if(l)return d.then(jsonRender(!0===l||l.split(",")));const m=u.renderer||t,f=new RenderKid;return f.style(e),d.then(e=>{m(u.template?f.render(u.template(e)):e),u.effect&&o&&u.effect(e)})}}},configure=configureKli,kli$1=configureKli({defaultRenderer:console.log});configureKli({defaultRenderer:console.log});var style={title:{display:"block",color:"bright-white",marginLeft:2,marginBottom:1},check:{display:"block",marginLeft:4},success:{display:"block",color:"grey",bullet:`"${chalk.green("✔")} "`},fail:{display:"block",color:"red",bullet:`"${chalk.red("✖")} "`},list:{display:"block",marginTop:1},item:{display:"block",marginBottom:1},change:{display:"block"},type:{color:"white"},scope:{color:"bright-white"},subject:{color:"grey"},attr:{display:"block",marginLeft:2},key:{color:"grey",marginRight:1},value:{color:"white"},bar:{display:"block",color:"green",bullet:`"${chalk.green("────────────────────────────────────────────────────────────────────────────────")}"`},h1:{display:"block",color:"bright-white",marginLeft:2}};const regex=/#(\d*)/;var parseTags=({rawTags:e=[]}={})=>e.map(e=>e.match(regex)||[]).filter(e=>e.length).map(([e,t])=>({tag:e,releaseNumber:parseInt(t,10)}));const git=configureGit();var gatherTags=()=>git.tags().then(({all:e})=>e),template=({changes:e})=>`\n    <bar>-</bar>\n    <h1>Changes</h1>\n    <bar>-</bar>\n    <list>\n        ${e.sort(()=>1).map(({type:e,scopes:t,subject:n})=>`\n                    <change>\n                        <type>${e}</type>\n                        <scope>(${t.join(",")})<scope>: \n                        <subject>${n}</subject>\n                    </change>\n                `).join("")}\n    </list>\n`;const regex$1=/^([^A-Z]*)\(((?:[^A-Z*]*)|\*)\): ([^a-z].*\.)$/,toHeaderOrBody=({body:e,matches:[,t,n,r]})=>t?{type:t,scopes:n.split(",").map(e=>e.trim()),subject:r}:{body:e},intoSingleCommits=(e,t)=>{if(0===e.length)return[t];var n=e.reverse(),r=toArray(n);const i=r[0],a=r.slice(1);return"body"in i&&"body"in t?[...a,_extends({},i,{body:[i.body,t.body].join("\n")})]:t.type?[...e,t]:[...a,_extends({},i,t)]},trimmedBodies=e=>e.body?_extends({},e,{body:e.body.trim()}):e;var parse$1=({commits:e=[]}={})=>Array.prototype.concat(...e.map(({hash:e,message:t,files:n})=>t.split(/\r?\n/).map(e=>({body:e,matches:e.match(regex$1)||[]})).map(toHeaderOrBody).reduce(intoSingleCommits,[]).map(trimmedBodies).map(t=>_extends({hash:e,files:n},t))));const git$1=configureGit();var gatherChanges=({from:e,to:t="HEAD"}={})=>git$1.log({from:e,to:t,format:{hash:"%H",message:"%B"}}).then(({all:e})=>Promise.all(e.map(e=>git$1.show(["--pretty=","--name-only",e.hash]).then(e=>e.trim().split("\n")).then(t=>_extends({},e,{files:t}))))).then(e=>({commits:e})).then(parse$1),latestReleaseTag=({tags:e=[]}={})=>e.filter(e=>e.releaseNumber).reduce((e,t)=>e.releaseNumber>t.releaseNumber?e:t,{tag:"HEAD",releaseNumber:0});const command=()=>({name:"changes",aliases:["changelog"],run:changes,template:template});var git$2=configureGit().outputHandler((e,t,n)=>{t.pipe(process.stdout),n.pipe(process.stderr)}),setupGit=()=>{var e=process.env;const t=e.GH_USER,n=e.GH_EMAIL,r=e.GH_REPO,i=e.GH_TOKEN;return console.log("Setting committer..."),git$2.addConfig("user.name",t).then(()=>git$2.addConfig("user.email",n)).then(()=>console.log("Setting up branch...")).then(()=>git$2.addRemote("origin-deploy",`https://${i}@github.com/${r}.git`)).then(()=>git$2.fetch("origin-deploy","master")).then(()=>git$2.checkout(["-B","deploy-master","--track","origin-deploy/master"])).then(()=>git$2.reset(["--hard","origin-deploy/master"]))},deployGit=()=>(console.log("Pushing to deploy remote..."),git$2.push(["origin-deploy","HEAD:master","--tags"]));const glob=promisify(unglob),lstat=promisify(fs__default.lstat),have=e=>t=>match(e,t);var findPackages=({root:e=".",exclude:t=[]}={})=>new Promise((()=>{var n=asyncToGenerator(function*(n,r){try{const i=path.resolve(e,"src/node_modules");if(!(yield lstat(i)).isDirectory)return r("The `src/node_modules` directory does not exist!");const a=path.resolve(i,"{[^@]*/,@*/*/}");return n((yield glob(a)).filter(function(e){return!t.some(have(e))}).map(function(t){return path.relative(path.resolve(e,"src/node_modules"),t)}))}catch(e){return r(e)}});return function(e,t){return n.apply(this,arguments)}})()),findRepoRoot=({anchor:e=".git"}={})=>findUp(e).then(path.dirname),template$1=({packages:e})=>`\n    <bar>-</bar>\n    <h1>Package List</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <attr><key>Name:</key><value>${e.name}</value></attr>\n                <attr><key>Version:</key><value>${e.version||"No version"}</value></attr>\n            </item>`).join("")}\n    </list>\n    `,findBaseConfig=({root:e="."}={})=>require(path.resolve(e,"package.json")),getPackageDetails=({root:e=".",packageNames:t=[]})=>t.map(t=>({name:t,dir:path.relative(e,path.resolve(e,"src/node_modules",t)),distDir:path.relative(e,path.resolve(e,"dist",t))})).map(t=>_extends({},t,{files:fs.readdirSync(path.resolve(e,t.dir))})).map(t=>{const n=path.resolve(e,t.dir,"package.json");if(fileExists.sync(n,{root:e}))return t;try{const e=require(n),r=pick(e,["version","bin","main"]);return _extends({},t,r,{config:e})}catch(e){return t}});const command$3=()=>({name:"list",aliases:["ls"],run:list,template:template$1});var template$2=({packages:e,dependencies:t})=>`\n    <bar>-</bar>\n    <h1>Package Dependencies</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <title>${e.name}</title>\n                <attr><key>Local:</key><value>${t[e.name].local.join(", ")||"--- None ---"}</value></attr>\n                <attr><key>External:</key><value>${t[e.name].external.join(", ")||"--- None ---"}</value></attr>\n            </item>`).join("")}\n    </list>\n    `,collapse=(e,t)=>{if(t.undefined){const n=e.undefined?[...e.undefined,t.undefined]:[t.undefined];return _extends({},e,{undefined:n})}return Object.assign(e,t)},parse$2=({content:e=""}={})=>{var t=frontMatter(e);const n=t.attributes,r=t.body;return{body:r.trim(),attributes:n,code:r.split("\n").reduce(({inBlock:e,bundle:t},n)=>"```"===n.slice(0,3)?{inBlock:!e,bundle:t}:e?{inBlock:e,bundle:t?`${t}\n${n}`:n}:{inBlock:e,bundle:t},{inBlock:!1,bundle:""}).bundle}};const lstat$1=promisify(fs__default.lstat),readFile=promisify(fs__default.readFile),cache={};var detective$1=({root:e,packages:t})=>(()=>{function n(){return r.apply(this,arguments)}var r=asyncToGenerator(function*({name:r,main:i,bin:a,files:s=[]}={}){if(!r)return{};const o=path.resolve(e,r),l=i||(a?Object.values(a)[0]:s.includes("index.md")?"index.md":"index.js");return fileExists.sync(path.resolve(o,l))?readFile(path.resolve(o,l),"utf-8").then(function(e){return".md"===path.extname(l)?parse$2({content:e}).code:e}).then(detective).then(function(r){return Promise.all(r.map((()=>{var r=asyncToGenerator(function*(r){try{if(r in cache)return cache[r];const i=path.resolve(e,r);return yield lstat$1(i),n(t[r]).then(function(e){return 0===Object.keys(e).length&&e.constructor===Object?{[r]:!1}:{[r]:e}}).then(function(e){return cache[r]=e,e})}catch(e){return{[r]:!1}}});return function(e){return r.apply(this,arguments)}})())).then(function(e){return e.reduce(collapse,{})})}):{}});return n})(),getDependencies=({root:e,packages:t=[]}={})=>{if(!e)return{};if(t.length<=0)return{};const n=path.resolve(e,"src","node_modules"),r=detective$1({root:n,packages:keyBy(t,"name")});return Promise.all(t.filter(({name:e})=>e).map(e=>r(e).then(e=>Object.entries(e).reduce(function e(t,[n,r]){return[...t,n,...Object.entries(r).reduce(e,[])]},[])).then(uniq).then(n=>({[e.name]:{local:n.filter(e=>find(t,{name:e})),external:n.filter(e=>!find(t,{name:e}))}})))).then(e=>e.reduce(collapse,{}))};const command$2=()=>({name:"dependencies",aliases:["deps","dependents"],run:dependencies,template:template$2}),readJson=promisify(jsonFile.readFile),writeJson=promisify(jsonFile.writeFile),git$3=configureGit();var updatePackages=({root:e,updates:t,publishable:n,latest:r})=>{const i=r.releaseNumber+1;return console.log(`Starting release #${i}`),console.log("Updating package.json files..."),Promise.all(n.filter(e=>e.name in t).map(({name:n,dir:r})=>{const i=path.resolve(e,r,"package.json");return readJson(i).then(e=>_extends({},e,{version:t[n].new})).then(e=>writeJson(i,e,{spaces:4})).then(()=>({name:n,version:t[n].new,file:i}))})).then((()=>{var e=asyncToGenerator(function*(e){return console.log("Staging files for commit..."),yield git$3.add(map(e,"file")),e});return function(t){return e.apply(this,arguments)}})()).then((()=>{var e=asyncToGenerator(function*(e){return console.log("Committing updates..."),yield git$3.commit(`release(${i}): Update package versions for ${e.length>1?`${e.length} packages.`:"1 package."}\n        \n${e.map(function({name:e,version:t}){return`v${t} ${e}`}).join("\n")}\n\n[skip ci]\n`),e});return function(t){return e.apply(this,arguments)}})()).then(e=>(console.log("Tagging commit with package versions..."),Promise.all(e.map(({name:e,version:t})=>git$3.addTag(`${e}-v${t}`))))).then(()=>(console.log("Tagging commit with new latest release tag..."),git$3.addTag(`#${i}`)))},template$3=({updates:e})=>`\n    <bar>-</bar>\n    <h1>Packages to be updated</h1>\n    <bar>-</bar>\n    <list>\n        ${Object.entries(e).map(([e,{old:t,new:n,type:r,reason:i}])=>`\n                    <item>\n                        <title>${e} - ${r}</title>\n                        <check>${i}</check>\n                        <check>${t} -> ${n}</check>\n                    </item>\n                `).join("")}\n    </list>\n    `;const createPatch=(e,t)=>({[e.name]:{type:"patch",old:e.version,new:semver.inc(e.version,"patch"),reason:t}});var recommendVersions=({publishable:e=[],packages:t=[],dependencies:n={},changes:r=[]}={})=>!e||e.length<=0?{}:e.filter(e=>e.name).map(e=>{if(e.version){if("0.0.0"===e.version)return{[e.name]:{type:"patch",old:e.version,new:"0.0.1",reason:"Prereleased"}};if(semver.lt(e.version,"0.1.0")){const t=filter(r,t=>!!t.scopes&&t.scopes.includes(e.name));if(t.length>0)return createPatch(e,`This had ${1===t.length?"1 change":`${t.length} changes`} while in development.`);if(!n[e.name])return;const i=filter(r,t=>!!t.scopes&&intersect(n[e.name].local,t.scopes).length>0);if(i.length>0)return createPatch(e,`There ${1===i.length?"was 1 change":`were ${i.length} changes`} in dependencies while in development.`)}else;}}).filter(e=>e).reduce(collapse,{});const registry=registryUrl(),setAuthToken=e=>new Promise((t,n)=>{process.chdir(e);const r=localOrHomeNpmrc();fs__default.existsSync(r)||n("For some reason no npmrc file exists.");const i=`${registry.replace("https:","").replace("http:","")}:_authToken=`,a=i+"${NPM_TOKEN}",s=fs__default.readFileSync(r,"utf-8").trim()+"\n";return-1!==s.indexOf(a)?(console.log("Just checked... .npmrc already has the token."),t()):-1!==s.indexOf(i)?(console.error("The .npmrc already has a token for this registry."),console.error(i),n(`Auth token for registry exists ${i}`)):(fs__default.writeFileSync(r,`${s}${a}\n`,"utf-8"),t())});var deployNpm=({root:e,publishing:t})=>setAuthToken(e).then(()=>Promise.all(t.map(t=>(process.chdir(path.resolve(e,"dist",t)),console.log(`Publishing [${t}]...`),execa("npm",["publish","--registry",registry]).then(e=>console.log(e.stdout)).catch(console.log))))),getPublishing=({destination:e={}}={})=>Object.entries(e).filter(([,{destVersion:e,srcVersion:t}])=>!!semver.valid(t)&&(!semver.valid(e)||semver.gt(t,e))).map(([e])=>e);const lstat$3=promisify(fs__default.lstat);var checkPackage=(()=>{var e=asyncToGenerator(function*(e={},t="."){const n={};try{const r=path.resolve(t,e.dir,"readme.md"),i=yield lstat$3(r);n["has readme file"]=!!i.isFile}catch(e){n["has readme file"]=!1}try{if(e.main||!e.bin){const r=path.resolve(t,e.dir,e.main||"index.js"),i=yield lstat$3(r);n["has main and/or all bin files"]=!!i.isFile}if(e.bin){const r=Object.values(e.bin),i=yield Promise.all(r.map(function(n){return path.resolve(t,e.dir,n)}).map((()=>{var e=asyncToGenerator(function*(e){return lstat$3(e)});return function(t){return e.apply(this,arguments)}})()));n["has main and/or all bin files"]=!i.some(function(e){return!e.isFile})}}catch(e){n["has main and/or all bin files"]=!1}n["has a version number"]=!!e.version;return Object.values(n).some(function(e){return!e})?{[e.name]:_extends({},n,{publishable:!1})}:{[e.name]:_extends({},n,{publishable:!0})}});return function(){return e.apply(this,arguments)}})();const lstat$2=promisify(fs__default.lstat);var publishCheck=({root:e,baseConfig:t={},packages:n=[]}={})=>new Promise((()=>{var r=asyncToGenerator(function*(r){if(0===n.length)return r([]);const i=yield Promise.all(n.map(function(t){return checkPackage(t,e)})),a={};try{const t=path.resolve(e,"LICENSE"),n=yield lstat$2(t);a["has root license"]=!!n.isFile}catch(e){a["has root license"]=!1}return a["has required package.json fields"]=every(["description","homepage","author","repository","bugs","license","dependencies"],function(e){return partial(has,e)}(t)),r({root:a,packages:i.reduce(collapse,{})})});return function(e){return r.apply(this,arguments)}})()),template$4=({checks:e})=>`\n    <bar>-</bar>\n    <h1>Checked Packages</h1>\n    <bar>-</bar>\n    <list>\n        ${Object.entries(e.packages).map(([e,t])=>`<item>\n                <title>${e}</title>\n                ${Object.entries(t).filter(([e])=>"publishable"!==e).map(([e,t])=>t?`<check><success>${e}</success></check>`:`<check><fail>${e}</fail></check>`).join("")}\n                <check>${Array(Object.keys(t).reduce((e,t)=>e.length>t.length?e:t,0).length+3).join("─")}</check>\n                <check>${t.publishable?"<success>publishable</success>":"<fail>not publishable</fail>"}</check>\n            </item>`).join("")}\n    </list>\n    <bar>-</bar>\n    <title>Repository</title>\n    ${Object.entries(e.root).map(([e,t])=>t?`<check><success>${e}</success></check>`:`<check><fail>${e}</fail></check>`).join("")}\n    `;const command$5=()=>({name:"check",run:check,template:template$4}),fields=["version"];var destinationDetails=({root:e,publishable:t})=>Promise.all(t.map(({name:t,distDir:n})=>Promise.all([execa("npm",["view",t,...fields]).then(e=>e.stdout).catch(()=>null),new Promise(t=>{try{return t(require(path.resolve(e,n,"package.json")).version)}catch(e){throw e}}).catch(()=>null)]).then(([e,n])=>({[t]:{destVersion:e,srcVersion:n}})))).then(e=>e.reduce(collapse,{})),template$5=({publishable:e,destination:t,publishing:n})=>`\n    <bar>-</bar>\n    <h1>Publishable Packages</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(({name:e})=>`<item>\n                    <check>\n                        ${n.includes(e)?`<success>${e}</success>`:`<fail>${e}</fail>`}\n                        <attr><key>NPM:</key><value>${t[e].destVersion}</value></attr>\n                        <attr><key>Next:</key><value>${t[e].srcVersion}</value></attr>\n                    </check>\n                </item>`).join("")}\n    </list>\n`;const command$4=()=>({name:"publish",aliases:["deploy"],run:publish,template:template$5,effect:(...e)=>{var t=process.env;const n=t.NPM_TOKEN,r=t.GH_USER,i=t.GH_EMAIL,a=t.GH_REPO,s=t.GH_TOKEN;if(!n)throw new Error("The NPM_TOKEN env variable must be set!");if(!r)throw new Error("The GH_USER env variable must be set!");if(!i)throw new Error("The GH_EMAIL env variable must be set!");if(!a)throw new Error("The GH_REPO env variable must be set!");if(!s)throw new Error("The GH_TOKEN env variable must be set!");return deployNpm(...e)}}),CI$1=process.env.CI,command$1=()=>({name:"version",aliases:["update"],run:version,template:template$3,effect:(...e)=>{if(!CI$1)throw new Error("Committing new versions should only happen in CI.");return setupGit().then(()=>updatePackages(...e)).then(()=>deployGit())}}),wait=e=>new Promise(t=>setTimeout(t,e));var getContents=({message:e="Create some contents: ",contents:t="",pause:n=2e3}={})=>(console.log(`${chalk.green("?")} ${chalk.white.bold(`${e}: `)} ${chalk.grey(`Opening your editor in ${n/1e3} secs...`)}`),wait(n).then(()=>({contents:editor.edit(t)})));const writeFile=promisify(fs__default.writeFile),writeJson$1=promisify(jsonFile.writeFile),fixers$1={"has readme file":({root:e,pkg:t,contents:n})=>(console.log("Creating [readme.md]..."),writeFile(path.resolve(e,t.dir,"readme.md"),n))};var effect=({root:e,package:t,fixes:n})=>(console.log("Creating [package.json]..."),Promise.all([...Object.entries(n).map(([n,r])=>fixers$1[n](_extends({root:e,pkg:t},r))),writeJson$1(path.resolve(e,t.dir,"package.json"),{version:"0.0.0"},{spaces:4})])),template$6=({package:{name:e},fixes:t})=>`\n    <bar>-</bar>\n    <h1>Prereleasing [${e}]</h1>\n    <bar>-</bar>\n    <list>\n    ${Object.entries(t).map(([e])=>"has readme file"===e?"\n                <check><success>A readme will be created.</success></check>\n            ":"")}\n        <check><success>A version will be added.</success></check>\n    </list>\n`;inquirer.registerPrompt("autocomplete",autocomplete);const searchPackages=e=>(t,n="")=>new Promise(t=>{setTimeout(()=>t(fuzzy.filter(n,e,{extract:e=>e.name}).map(e=>e.original||e)),500)});var pickPackage=({message:e="Which package should we pick?",packages:t})=>inquirer.prompt([{type:"autocomplete",name:"name",message:e,source:searchPackages(t)}]).then(({name:e})=>find(t,{name:e}));const solvable=["has readme file"],fixers={"has readme file":e=>getContents({message:`Write your readme.md for ${e.name}`,contents:`# ${e.name}`})},command$6=()=>({name:"prerelease",run:prerelease,template:template$6,effect:effect}),paths=(e,t=[],n)=>t.reduce((t,r)=>_extends({},t,{[r]:path.resolve(n,e[r])}),{});var build$1=({root:e,config:t})=>rollup.rollup(_extends({},t.in,paths(t.in,["input"],e))).then(n=>Promise.all(t.out.map(t=>n.write(_extends({},t,paths(t,["file"],e),{exports:n.exports.length>1?"named":0===n.exports.length?"none":"default"===n.exports[0]?"default":"named"})))));const copy=promisify(fs__default.copyFile),writeJson$2=promisify(jsonFile.writeFile),requiredProps=["description","homepage","author","repository","bugs","license"];var postBuild=({root:e,baseConfig:t,config:n})=>Promise.all([copy(path.resolve(e,"LICENSE"),path.resolve(e,n.destDir,"LICENSE")),copy(path.resolve(e,n.srcDir,"readme.md"),path.resolve(e,n.destDir,"readme.md")),writeJson$2(path.resolve(e,n.destDir,"package.json"),_extends({name:n.name},n.packageConfig,pick(t,requiredProps),{dependencies:n.dependencyVersions}),{spaces:4})]);const babelConfig={babelrc:!1,presets:[["env",{modules:!1,targets:{node:"6"}}],"stage-0"],plugins:["external-helpers"],exclude:["node_modules/**"]},commonPlugins=[markdown(),resolve$1({customResolveOptions:{moduleDirectory:["src/node_modules","node_modules"]}}),babel(babelConfig),uglify({},uglifyEs.minify),filesize()],input=({pkg:e,plugins:t,dependencies:n})=>({input:`./src/node_modules/${e.name}/${e.file}`,external:n[e.name].external,plugins:t}),output=({format:e,pkg:t,banner:n})=>({file:`./dist/${t.name}/${t.file}`,format:e,banner:n}),postInfo=({pkg:e,dependencies:t,baseConfig:n})=>({name:e.name,srcDir:`./src/node_modules/${e.name}`,destDir:`./dist/${e.name}`,packageConfig:e.config,dependencyVersions:pick(n.dependencies,intersect(t[e.name].external,Object.keys(n.dependencies)))}),banner="#!/usr/bin/env node",type="npm-cli-tool",plugins$1=[...commonPlugins,exec()];var npmCli={type:type,filter:e=>e.bin&&e.bin.constructor===Object,config:({baseConfig:e,dependencies:t})=>n=>Object.values(n.bin).map(e=>_extends({},n,{file:e})).map(n=>({type:type,in:input({pkg:n,dependencies:t,plugins:plugins$1}),out:[output({format:"cjs",pkg:n,banner:banner})],post:postInfo({pkg:n,baseConfig:e,dependencies:t})})),build:build$1,postBuild:postBuild};const writeFile$1=promisify(fs__default.writeFile);var entyre=({readmePath:e="./readme.md",packageJsonPath:t="./package.json",config:n={},readme:r=""}={})=>({name:"entyre",transform(e,t){if(".md"!==path.extname(t))return{code:e};var i=parse$2({content:e});const a=i.body,s=i.code;var o=i.attributes;return r=a,n=void 0===o?{}:o,{code:s}},onwrite:()=>asyncToGenerator(function*(){return Promise.all([writeFile$1(t,JSON.stringify(n,null,4),"utf-8"),writeFile$1(e,r,"utf-8")])})()});const type$1="entyre-package";var entyrePackage={type:type$1,filter:e=>e.main&&".md"===path.extname(e.main)||e.files.includes("index.md"),config:({baseConfig:e,dependencies:t})=>n=>{const r=_extends({},n,{file:n.main||"index.md"});return{type:type$1,in:input({pkg:r,dependencies:t,plugins:[entyre({readmePath:`./dist/${r.name}/readme.md`,packageJsonPath:`./dist/${r.name}/package.json`}),...commonPlugins]}),out:[output({pkg:_extends({},r,{file:"index.js"}),outFile:"index.js",format:"cjs"})],post:postInfo({pkg:r,baseConfig:e,dependencies:t})}},build:build$1,postBuild:()=>{}};const removeDir=promisify(rimraf);var buildPackages=e=>({root:t,baseConfig:n,configs:r=[]}={})=>removeDir(path.resolve(t,"dist")).then(()=>Promise.all(r.map(r=>e[r.type].build({root:t,config:r}).then(()=>e[r.type].postBuild({root:t,baseConfig:n,config:r.post})))));const copy$1=promisify(fs__default.copyFile),type$2="vue-site",plugins$2=[vuePlugin({css:!0}),commonjs(),globals(),...commonPlugins];var vueSite={type:type$2,filter:e=>e.files.includes("index.html")&&e.files.includes("app.js"),config:({baseConfig:e,dependencies:t})=>n=>{const r=_extends({},n,{file:"app.js"});return{type:type$2,in:input({pkg:r,dependencies:t,plugins:plugins$2}),out:[output({format:"iife",pkg:r})],post:postInfo({pkg:r,baseConfig:e,dependencies:t})}},build:build$1,postBuild:({root:e,baseConfig:t,config:n})=>postBuild({root:e,baseConfig:t,config:n}).then(()=>copy$1(path.resolve(e,n.srcDir,"index.html"),path.resolve(e,n.destDir,"index.html")))};const type$3="npm-package";var npmPackage={type:type$3,filter:e=>!e.bin&&(e.main||e.files.includes("index.js")),config:({baseConfig:e,dependencies:t})=>n=>{const r=_extends({},n,{file:n.main||"index.js"});return{type:type$3,in:input({pkg:r,dependencies:t,plugins:commonPlugins}),out:[output({pkg:r,format:"cjs"})],post:postInfo({pkg:r,baseConfig:e,dependencies:t})}},build:build$1,postBuild:postBuild},buildRollupConfigs=e=>({packages:t=[],baseConfig:n,dependencies:r}={})=>[].concat(...Object.entries(e).filter(([,e])=>t.some(e.filter)).map(([,e])=>[].concat(...t.filter(e.filter).map(e.config({baseConfig:n,dependencies:r})))));const plugins=[npmPackage,npmCli,vueSite,entyrePackage].reduce((e,t)=>_extends({},e,{[t.type]:t}),{}),command$7=()=>({name:"build",renderer:()=>{},run:build,effect:buildPackages(plugins),args:{_:"packageNames"}}),CI=process.env.CI,kli=configure({defaultStyle:CI?{}:style}),cli=kli({commands:[command$7(),command(),command$5(),command$2(),command$3(),command$6(),command$4(),command$1()]});cli.execute(process.argv.slice(2));
